﻿/* ============================================================
* Author:       xieqin
* Time:         2014/11/11 11:18:27
* FileName:     EventInterface
* Purpose:      event interface
* =============================================================*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Event
{
    //Event接口
    public interface IEventBase
    {
        int Id
        {
            get;
        }
    }

    public delegate void EvtHandler(IEventBase Event);

    //事件系统接口
    public interface IEventSystem
    {
        EventTag AddListener<T>(int eventId, Action<T> handler) where T : class, IEventBase;

        EventTag AddListener<T>(Action<T> handler) where T : class, IEventBase, new();

        void RemoveListener(EventTag tag);

        void SendEvent(IEventBase ev);
        void Destroy();
    }
}
